#include <Servo.h>
#include <URMSerial.h>
#include <SoftwareSerial.h>

#define SPEED_LEFT      6
#define SPEED_RIGHT     5 
#define DIR_LEFT        7
#define DIR_RIGHT       4
#define DISTANCE        1
#define TEMPERATURE     2
#define ERROR       3
#define NOTREADY 4
#define TIMEOUT 5

URMSerial urm;


Servo motorHead;

int DalnomerRightPin = A1;

int servoLeftPin=9;
int servoRightPin=10;
int servoHeadPin=11; //Сервопривод с дальномером

const int buttonPin = 8; //Кнопка находится на 8-ом пине
boolean ProcFinish = true;
int buttonState = 0; //Состояние кнопки
int DalnomerRightValue = 0; //Изначальное значение правого расстояния
int DalnomerForwardValue = 0; //Изначальное значение переднего расстояния
int DistRight = 400; //Допустимая дистанция справа, используется для движения вдоль стены правым боком
int DistForward = 32; //Допустимая дистанция спереди на этом расстоянии робот должен отруливать
int MaxDistRight = 150; //Мвксимальная дистанция справа. Чем меньше тем дальше
int MimDistRight = 250; //Минимальная дистанция справа. Чем больше тем ближе


int var =0 ;
int on=0;



void go(int speed, bool reverseLeft, bool reverseRight, int duration)
{
    // Для регулировки скорости `speed` может принимать значения от 0 до 255,
    // чем болше, тем быстрее. 
    analogWrite(SPEED_LEFT, speed);
    analogWrite(SPEED_RIGHT, speed);
    digitalWrite(DIR_LEFT, reverseLeft ? LOW : HIGH); 
    digitalWrite(DIR_RIGHT, reverseRight ? LOW : HIGH); 
    delay(duration); 
}
 
 
void MoveRobot(int direct, int degres)
{
  //Процедура движения робота 
  //direct - направелние 0 - вперед, 1- поворот направо,
  // 2-назад, 3-поворот налево
  // degres - Угол поворота в поворотах и расстояние двидения в штуках
  // при движении вперед и назад
  ProcFinish = false; //выставляем признак выполение процедуры чтобы она не запустилась повторно
  switch (direct) {
  case 0:
    //движение вперед
    //Опытным путем полученный прямой ход
  
     go(200, true, true, derges*41);
    break;
  case 1:
    // вращение в право
    // опытным путем получено что 2100 = 360 градусов 
    degres = map(degres, 1, 360, 1, 2100);

   go(200, true, false, derges);
 
    break;
  case 2:
    //Движение назад
  
 go(200, false, false, derges*41);
    
    break;
  case 3:
    // вращение налево
    // опытным путем получено что 2100 = 360 градусов 
    degres = map(degres, 1, 360, 1, 2100);
  
 go(200, false, true, derges);
    break;  
  default: //ежли вдруг не то передали, то ни кудп и не едем
   go(0, true, true,0);
  }
}
/////////////////////

int proceederror()
{
  int valueR;
  int valueL;
  motorHead.write(75);
  delay(500);
  switch(urm.requestMeasurementOrTimeout(DISTANCE, valueR)) // Find out the type of request
    {
        case DISTANCE: // Double check the reading we recieve is of DISTANCE type
            //    Serial.println(value); // Fetch the distance in centimeters from the URM37
            Serial.print("Forward RIGHT: ");
            Serial.println(valueR);
            break;
        case ERROR:
            Serial.println("Forward RIGHT = ERROR");
            valueR=10000;
            break;
     } 

  motorHead.write(105);
  delay(500);  
   switch(urm.requestMeasurementOrTimeout(DISTANCE, valueL)) // Find out the type of request
    {
        case DISTANCE: // Double check the reading we recieve is of DISTANCE type
            //    Serial.println(value); // Fetch the distance in centimeters from the URM37
            Serial.print("Forward LEFT: ");
            Serial.println(valueL);
            break;
        case ERROR:
            Serial.println("Forward LEFT = ERROR");
            valueL=10000;
            break;
     } 
  //delay(1000);
  motorHead.write(90);
  //Возвращаем меньшее из полученных значений
  if (valueL < valueR) 
  {
    return valueL;
  }
  else
  {
    return valueR;
  }
}


//////////////////////////////////////////////
//Процедура замера расстояния
int distance() // run over and over
{
  int value; // This value will be populated
    // Request a distance reading from the URM37
measurement:     
    switch(urm.requestMeasurementOrTimeout(DISTANCE, value)) // Find out the type of request
    {
        case DISTANCE: // Double check the reading we recieve is of DISTANCE type
            //    Serial.println(value); // Fetch the distance in centimeters from the URM37
            Serial.print("Forward: ");
            Serial.println(value);
            return value;
            break;
        case TEMPERATURE:
            return value;
            break;
        case ERROR:
            MoveRobot(5, 90); //останавливаемся
            Serial.println("Error");
            value=proceederror();
            Serial.print("Correct Forward: ");
            Serial.println(value);
            return value;
            break;
        case NOTREADY:
            Serial.println("Not Ready");
            break;
        case TIMEOUT:
            Serial.println("Timeout");
            break;
    } 

    return -1;
}



void FollowWall()
{
  int  DalnomerRightCurrent;
  int LastRightPos = MimDistRight; //Используется для запоминания позиции с которой начинаем корректировку курса. 
                          //Если при следующем измерении текущая позиции оказывается больше запомненной LastRightPos
                          //то корректируем еще раз иначе ни чего не делаем он и так отдаляется
  int LastLefttPos = MaxDistRight ; //Используется для запоминания позиции с которой начинаем корректировку курса. 
                          //Если при следующем измерении текущая позиции оказывается меньше запомненной LastLefttPos
                          //то корректируем еще раз иначе ни чего не делаем он и так приближается
 
  // едем до первой стены
  while  (distance() > DistForward)
 { 
  MoveRobot(0, 1);
 } 
povorot:
  digitalWrite(13, HIGH);
  MoveRobot(3, 90); //3 - вращение в налево
  digitalWrite(13, LOW);
  MoveRobot(5, 90);//Остановиться
  //delay(3000); // Почему то, дальномер 
forvard:
//  MoveRobot(5, 90);//Остановиться
  DalnomerForwardValue = distance(); //замеряем расстояние спереди
//  delay(3000); // stop
   if (DalnomerForwardValue < DistForward) goto povorot; //если есть припятствие то поворачиваем влево еще раз

  MoveRobot(0, 1); //если припятствия нет 0 - двигаться вперед
  DalnomerRightCurrent=analogRead(DalnomerRightPin);
   Serial.print("Distation Right:");
   Serial.println(DalnomerRightCurrent); 
 if (DalnomerRightCurrent >= MaxDistRight  && DalnomerRightCurrent < MimDistRight) //проверка на то что мы попали в корридор движения прямо
   //отменяем корректировочный угол
   {
     if (LastLefttPos != MaxDistRight) 
         {
          MoveRobot(3, 5); //Возвращаем робота на прямой курс
         }
         else if (LastRightPos != MimDistRight)
         {
          MoveRobot(1, 5); //Возвращаем робота на прямой курс  
         }     
   }
   
   
       
  // проверка на конец внешнего угла
            if (DalnomerRightCurrent <= 50)
            {
             Serial.println("Possible end of wall");
             Serial.print("Distation Right:");
             Serial.println(analogRead(DalnomerRightPin));  
             //если стена закончтилась т.е. расстояние <50 то надо проехать угол, повернуть направо, проехать еще 25 сантиметров
             //Сначало  проедем немного и убедимся что это правда кончился угол а не дырка в стене
             MoveRobot(0, 15); //0 - двигаться вперед
             if (analogRead(DalnomerRightPin) <= 50)
               {  
                Serial.println("Exactly end of wall!!!");  
                Serial.print("Distation Right:");
                Serial.println(analogRead(DalnomerRightPin));   
                digitalWrite(12, HIGH);
                MoveRobot(1, 90); //3 - вращение в право 90
                MoveRobot(0, 20); // 0 - двигаться вперед
                digitalWrite(12, LOW);
                MoveRobot(5, 90);//Остановиться
                delay(500); // stop
               }
            }  
            else if (DalnomerRightCurrent >= MimDistRight && DalnomerRightCurrent > LastRightPos) //если приближаемся к стене то отруливаем от него влево 
            {                                                              // и если корректировка выключена то заходим и корректируем   
              digitalWrite(6, HIGH);
              LastRightPos = DalnomerRightCurrent; //Сохранили позицуу с которой начали корректировку
              MoveRobot(3, 5); //3 - отворачиваем в лево 3 градус
                Serial.println("correct course in left:");
              digitalWrite(6, LOW);
            }
            else if (( DalnomerRightCurrent < MaxDistRight  && DalnomerRightCurrent > 50) && DalnomerRightCurrent < LastLefttPos) //если отдаляемся к стены то подруливаем к ней вправо 
            {                                                                                          // и если корректировка выключена то заходим и корректируем   
                  digitalWrite(7, HIGH);  
                  LastLefttPos = DalnomerRightCurrent; //запоминаем позицию от которой начинаем отруливать
                  MoveRobot(1, 5); //3 - отворачиваем в право 3 градус
                    Serial.println("correct course in right:");
                  digitalWrite(7, LOW);
             }
           goto forvard;
}


void setup() 
{
    // Настраивает выводы платы 4,5,6,7 на вывод сигналов 
    for(int i = 5; i <= 8; i++)     
        pinMode(i, OUTPUT);  
         //Подключаю серво объект
  motorHead.attach(servoHeadPin);
  pinMode(buttonPin, INPUT); //Кнопка для включения программы
  pinMode(13, OUTPUT); //Светодиодик
  pinMode(12, OUTPUT); //Светодиодик
  pinMode(7, OUTPUT); //Светодиодик
  pinMode(6, OUTPUT); //Светодиодик
  urm.begin(2,3,9600); //RX Pin, TX Pin Подключаем сериал соединение дль дальномера
}



void loop()
{
   buttonState = digitalRead(buttonPin);
   if (buttonState == HIGH || on ==1)
   { 
     on=1;
    motorHead.write(90);  
    FollowWall();
   

   }
    
  
}   

 
   
